﻿using Ozeki.VoIP;
using System;
using Ozeki.Media;

namespace _06_IVR_using_XML_Multi_Level
{
    class SpeakCommand : ICommand
    {
        PhoneCallAudioSender _phoneCallAudioSender;
        MediaConnector _mediaConnector;
        ICall _call;
        TextToSpeech _tts;
        string _text;
        bool _isStarted;

        public SpeakCommand(string text)
        {
            _text = text;
        }

        public void Start(ICall call)
        {
            _isStarted = true;
            _call = call;
            _phoneCallAudioSender = new PhoneCallAudioSender();
            _mediaConnector = new MediaConnector();
            _phoneCallAudioSender.AttachToCall(call);
            TextToSpeech(_text);
        }

        public void Cancel()
        {
            if (_tts != null)
            {
                _mediaConnector.Disconnect(_tts, _phoneCallAudioSender);
                _mediaConnector.Dispose();
            }
        }

        public event EventHandler Completed;

        private void TextToSpeech(string p)
        {
            _tts = new TextToSpeech();
            _tts.Stopped += tts_Stopped;
            _mediaConnector.Connect(_tts, _phoneCallAudioSender);
            _tts.AddAndStartText(p);
        }

        void tts_Stopped(object sender, EventArgs e)
        {
            if (!_isStarted)
                return;
            _isStarted = false;
            
            var handler = Completed;
            if (handler != null)
                handler(this, EventArgs.Empty);
            
        }
    }
}
